<?php
/**
 * @package Wapple_Architect
 * @subpackage WAPL Theme
 */
include_once('functions.php');
$waplString = get_wapl_header();
$wapl = new WordPressWapl;

if(have_posts())
{
	while(have_posts())
	{
		the_post();
		
		//Open the row
		$navString = '<row class="navigation">';

		// Get next and previous posts
		$prevlink = '';
		$nextlink = '';
		if(function_exists('get_adjacent_post'))
		{
			$prevlink = get_permalink(get_adjacent_post(false, '', true));
			$nextlink = get_permalink(get_adjacent_post(false, '', false));
		} else if(function_exists('get_previous_post'))
		{
			$prevlink = get_permalink(get_previous_post(false, ''));
			$nextlink = get_permalink(get_next_post(false, ''));
		}
		
		// previous post link
		$doEmpty = true;
		if($prevlink != get_permalink())
		{
			$navString .= $wapl->link(array('row' => false, 'url' => $prevlink, 'label' => 'previous post'));
			$doEmpty = false;
		}
		
		// next post link
		if($nextlink != get_permalink())
		{
			$navString .= $wapl->link(array('row' => false, 'url' => $nextlink, 'label' => 'next post'));
			$doEmpty = false;
		}
		
		if($doEmpty == true)
		{
			$navString .= '<cell></cell>';
		}
		// Close the row
		$navString .= '</row>';
		
		if(get_option('architect_single_shownext'))
		{
			$waplString .= $navString;
		}
		
		$waplString .= $wapl->chunk('words', array('class' => 'postTitle', 'display_as' => 'h2', 'quick_text' => get_the_title()));
		
		// Sanity checking on content
		$singlepagescale = ARCHITECT_SINGLE_IMAGESCALE;
		if(get_option('architect_single_imagescale'))
		{
			$singlepagescale = get_option('architect_single_imagescale');
		}
		$singlepagequality = ARCHITECT_SINGLE_IMAGEQUALITY;
		if(get_option('architect_single_imagequality'))
		{
			$singlepagequality = get_option('architect_single_imagequality');
		}
		
		if(get_option('architect_single_dopaging'))
		{
			if(!$length = get_option('architect_single_paginglength'))
			{
				$length = null;
			}
		} else
		{
			$length = null; 
		}
		
		$content = $wapl->format_text(get_the_content(), $singlepagescale, $singlepagequality, 'entry_row', $length);
		
		$totalPages = count($wapl->pages);
		if($wapl->currentPage > $totalPages)
		{
			$waplString .= $wapl->chunk('words', array('class' => 'entry_row', 'quick_text' => 'This page could not be found'));
		} else
		{
			$waplString .= $wapl->chunk('words', array('class' => 'entry_row', 'quick_text' => $content));
		}
		
		if($wapl->currentPage >= $totalPages)
		{
			if($wapl->currentPage > 1)
			{
				$link = 'page='.($wapl->currentPage - 1);
				if(isset($_GET) AND !empty($_GET) AND (count($_GET) > 1 OR ((count($_GET) == 1) AND (!isset($_GET['page']) OR $_GET['page'] == ''))))
				{
					$link = '&amp;'.$link;
				}  else
				{
					$link = '?'.$link;
				}
				
				$waplString .= $wapl->link(array('label' => 'prev', 'url' => get_permalink().$link));
			}
			
			// Details about post
			if(function_exists('get_the_ID'))
			{
				$categories = get_the_category(get_the_ID());
			} else
			{
				global $id;
				$categories = get_the_category($id);
			}
			$catString = '';
			foreach($categories as $cat)
			{
				if(isset($cat->name))
				{
					$catString .= $cat->name.',';
				} else if(isset($cat->cat_name))
				{
					$catString .= $cat->cat_name.',';
				}
			}
			$catString = rtrim($catString,',');
	
			$postText = 'This entry was posted on '.get_the_time('l, F jS, Y').' at '.get_the_time().' and is filed under '.$catString.'.';
			
			$waplString .= $wapl->chunk('words', array('class' => 'postmetadata alt', 'quick_text' => $postText));
			
			// Comments
			global $wpdb;
			if(method_exists($wpdb, 'prepare'))
			{
				$comments = $wpdb->get_results($wpdb->prepare("SELECT * FROM $wpdb->comments WHERE comment_post_ID = %d AND  comment_approved = '1' ORDER BY comment_date", get_the_ID()));
			} else
			{
				global $post;
				$comments = $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE comment_post_ID = '$post->ID' AND comment_approved = '1' ORDER BY comment_date");
			}
			
			// number of comments
			$waplString .= $wapl->chunk('words', array('class' => 'postmetadata', 'display_as' => 'h3', 'quick_text' => get_wapl_response_string(get_option('architect_single_responseformat'), count($comments), get_the_title())));
			if(isset($comments) AND !empty($comments))
			{
				foreach($comments as $comment)
				{
					// display all comments
					$waplString .= $wapl->chunk('words', array('class' => 'postmetadata waplsmall commentlist', 'quick_text' => $comment->comment_author.' says :'));
					$waplString .= $wapl->chunk('words', array('class' => 'postmetadata waplsmall commentlist', 'quick_text' => get_the_time('l, F jS, Y', $comment->comment_ID)));
					$waplString .= $wapl->chunk('words', array('class' => 'postmetadata waplsmall commentlist', 'quick_text' => $comment->comment_content));
				}
			}
			
		} else if($wapl->currentPage < $totalPages)
		{
			$waplString .= '<row>';
			if($wapl->currentPage > 1)
			{
				$link = 'page='.($wapl->currentPage - 1);
				if(isset($_GET) AND !empty($_GET) AND (count($_GET) > 1 OR ((count($_GET) == 1) AND (!isset($_GET['page']) OR $_GET['page'] == ''))))
				{
					$link = '&amp;'.$link;
				}  else
				{
					$link = '?'.$link;
				}
				$waplString .= $wapl->link(array('row' => false, 'label' => 'prev', 'url' => get_permalink().$link));
			}
			if($wapl->currentPage < $totalPages)
			{
				$link = 'page='.($wapl->currentPage + 1);
				if(isset($_GET) AND !empty($_GET) AND (count($_GET) > 1 OR ((count($_GET) == 1) AND (!isset($_GET['page']) OR $_GET['page'] == ''))))
				{
					$link = '&amp;'.$link;
				}  else
				{
					$link = '?'.$link;
				}
				$waplString .= $wapl->link(array('row' => false, 'label' => 'next', 'url' => get_permalink().$link));
			}
			$waplString .= '</row>';
		}
		
		// Add nav string to bottom
		if(get_option('architect_single_shownext'))
		{
			$waplString .= $navString;
		}
	}
} else
{
	$waplString .= $wapl->chunk('words', array('quick_text' => 'Sorry, no posts matched your criteria.'));
}

$waplString .= get_wapl_footer();

process_wapl($waplString);
?>